/******************************************************************************\
|*                                                                            *|
|*                         Neurotechnologija Core 2.0                         *|
|*                                                                            *|
|* NErrors.h                                                                  *|
|* Error codes definition                                                     *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef N_ERRORS_H_INCLUDED
#define N_ERRORS_H_INCLUDED

#ifdef N_CPP
extern "C"
{
#endif

#define N_OK                                     0
#define N_E_FAILED                              -1
	#define N_E_CORE                            -2
		#define N_E_NULL_REFERENCE              -3
		#define N_E_OUT_OF_MEMORY               -4
		#define N_E_NOT_IMPLEMENTED             -5
		#define N_E_NOT_SUPPORTED               -6
		#define N_E_INVALID_OPERATION           -7
		#define N_E_OVERFLOW                    -8
		#define N_E_INDEX_OUT_OF_RANGE          -9
		#define N_E_ARGUMENT                   -10
			#define N_E_ARGUMENT_NULL          -11
			#define N_E_ARGUMENT_OUT_OF_RANGE  -12
		#define N_E_FORMAT                     -13
		#define N_E_IO                         -14
			#define N_E_END_OF_STREAM          -15

	#define N_E_PARAMETER                     -100
	#define N_E_PARAMETER_READ_ONLY           -101

	#define N_E_NOT_REGISTERED                -200

#define NFailed(result) ((result) < 0)
#define NSucceeded(result) ((result) >= 0)

#ifdef N_CPP
}
#endif

#endif // !N_ERRORS_H_INCLUDED
