/******************************************************************************\
|*                                                                            *|
|*                        Neurotechnologija Images 2.0                        *|
|*                                                                            *|
|* NImage.h                                                                   *|
|* Header file for NImage module                                              *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef N_IMAGE_H_INCLUDED
#define N_IMAGE_H_INCLUDED

#include "NPixelFormat.h"

#ifdef N_CPP
extern "C"
{
#endif

N_DECLARE_HANDLE(HNImage)

#ifdef N_CPP
}
#endif

#include "NImageFormat.h"

#ifdef N_CPP
extern "C"
{
#endif

NResult N_API NImageCreateWrapper(NPixelFormat pixelFormat,
	NUInt width, NUInt height, NSizeType stride, NFloat horzResolution, NFloat vertResolution,
	void * pixels, NBool ownsPixels, HNImage * pHImage);
NResult N_API NImageCreate(NPixelFormat pixelFormat,
	NUInt width, NUInt height, NSizeType stride, NFloat horzResolution, NFloat vertResolution,
	HNImage * pHImage);
NResult N_API NImageCreateFromData(NPixelFormat pixelFormat,
	NUInt width, NUInt height, NSizeType stride, NFloat horzResolution, NFloat vertResolution,
	NSizeType srcStride, const void * srcPixels, HNImage * pHImage);
NResult N_API NImageCreateFromImage(NPixelFormat pixelFormat,
	NSizeType stride, HNImage hSrcImage, HNImage * pHImage);
NResult N_API NImageCreateFromImageEx(NPixelFormat pixelFormat,
	NSizeType stride, NFloat horzResolution, NFloat vertResolution, HNImage hSrcImage, HNImage * pHImage);
NResult N_API NImageCreateFromFile(const NChar * szFileName, HNImageFormat hImageFormat, HNImage * pHImage);

void N_API NImageFree(HNImage hImage);

NResult N_API NImageClone(HNImage hImage, HNImage * pHClonedImage);
NResult N_API NImageSaveToFile(HNImage hImage, const NChar * szFileName, HNImageFormat hImageFormat);

NResult N_API NImageGetPixelFormat(HNImage hImage, NPixelFormat * pValue);
NResult N_API NImageGetWidth(HNImage hImage, NUInt * pValue);
NResult N_API NImageGetHeight(HNImage hImage, NUInt * pValue);
NResult N_API NImageGetStride(HNImage hImage, NSizeType * pValue);
NResult N_API NImageGetSize(HNImage hImage, NSizeType * pValue);
NResult N_API NImageGetHorzResolution(HNImage hImage, NFloat * pValue);
NResult N_API NImageGetVertResolution(HNImage hImage, NFloat * pValue);
NResult N_API NImageGetPixels(HNImage hImage, void * * pValue);

#ifdef N_CPP
}
#endif

#endif // !N_IMAGE_H_INCLUDED
