/******************************************************************************\
|*                                                                            *|
|*          Neurotechnologija Fingerprint Features Extractor VF 1.0           *|
|*                                                                            *|
|* VFExtractor.h                                                              *|
|* Header file for VFExtractor module                                         *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef VF_EXTRACTOR_H_INCLUDED
#define VF_EXTRACTOR_H_INCLUDED

#include "NFRecord.h"
#include "NImages.h"
#include "VFExtractorParams.h"

#ifdef N_CPP
extern "C"
{
#endif

N_DECLARE_HANDLE(HVFExtractor);

NBool N_API VfeIsRegistered(void);
NResult N_API VfeCopyParameters(HVFExtractor hDstExtractor, HVFExtractor hSrcExtractor);

NResult N_API VfeCreate(HVFExtractor * pHExtractor);

void N_API VfeFree(HVFExtractor hExtractor);

NResult N_API VfeReset(HVFExtractor hExtractor);
NResult N_API VfeGetMaxTemplateSize(HVFExtractor hExtractor, NSizeType * pSize);
NResult N_API VfeExtract(HVFExtractor hExtractor,
	NUShort width, NUShort height, NSizeType stride, NUShort horzResolution, NUShort vertResolution, NByte * pixels,
	NFPosition position, NFImpressionType impressionType,
	void * buffer, NSizeType bufferSize, NSizeType * pSize);
NResult N_API VfeExtractFromImage(HVFExtractor hExtractor,
	HNImage hImage,
	NFPosition position, NFImpressionType impressionType,
	void * buffer, NSizeType bufferSize, NSizeType * pSize);
NResult N_API VfeExtractUnpacked(HVFExtractor hExtractor,
	NUShort width, NUShort height, NSizeType stride, NUShort horzResolution, NUShort vertResolution, NByte * pixels,
	NFPosition position, NFImpressionType impressionType, HNFRecord * pHRecord);
NResult N_API VfeExtractUnpackedFromImage(HVFExtractor hExtractor, HNImage hImage,
	NFPosition position, NFImpressionType impressionType, HNFRecord * pHRecord);
NResult N_API VfeGeneralizeUnpacked(HVFExtractor hExtractor, NInt templateCount, const void * * arTemplates, const NSizeType * arTemplateSizes,
	HNFRecord * pHRecord, NInt * pBaseTemplateIndex);
NResult N_API VfeGeneralize(HVFExtractor hExtractor, NInt templateCount, const void * * arTemplates, const NSizeType * arTemplateSizes,
	void * buffer, NSizeType bufferSize, NSizeType * pSize, NInt * pBaseTemplateIndex);
NResult N_API VfeGetParameter(HVFExtractor hExtractor, NUInt parameterId, void * pValue);
NResult N_API VfeSetParameter(HVFExtractor hExtractor, NUInt parameterId, const void * pValue);

#ifdef N_CPP
}
#endif

#endif // !VF_EXTRACTOR_H_INCLUDED
