
#include "stdafx.h"
#include "VFDemo.h"
#include "VFDemoDlg.h"
#include "VFDemoOptions.h"
#include "afxwin.h"
#include "atlbase.h"
#include "tchar.h"
#include "afxcmn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CMyStatic::CMyStatic(): CStatic()  // My own control  - derived from CStatic class - right view (processed image)
{
}

CMyStatic::~CMyStatic() 
{
}

BEGIN_MESSAGE_MAP(CMyStatic, CStatic)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

void CMyStatic::OnPaint(){   //Drawing my static class
	CVFDemoDlg* demoDlg = (CVFDemoDlg*)this->GetParent();
	if (demoDlg->extracted) {
		CPaintDC dc(this); // device context for painting
		this->SetBitmap(demoDlg->bitmapEx);

		CRect rect;
		GetClientRect(rect);

		CDC sdc;
		sdc.CreateCompatibleDC(NULL);
		sdc.SelectObject(demoDlg->bitmapEx);

		dc.BitBlt(0, 0, rect.right, rect.bottom, &sdc, 0, 0, SRCCOPY);
		
		COLORREF minutiaColor = RGB(255,0,0);
		if (demoDlg->featuresEx && demoDlg->imageEx->Width() > 0)
		{
			int xx, yy, s = demoDlg->FeatToLocal(4);
			CPen RedPen(PS_SOLID,1,RGB(255, 0, 0));
			CPen* oldPen = dc.SelectObject(&RedPen);
			CBrush* brush = CBrush::FromHandle((HBRUSH)GetStockObject(NULL_BRUSH));
			CBrush* oldBrush = dc.SelectObject(brush);

			for (int i = 0; i < demoDlg->featuresEx->Minutiae.GetSize(); i++)
			{
				xx = demoDlg->FeatToLocal(demoDlg->featuresEx->Minutiae[i].X);
				yy = demoDlg->FeatToLocal(demoDlg->featuresEx->Minutiae[i].Y);
				if (xx > rect.left && xx < rect.right && yy > rect.top && yy < rect.bottom)
				{
					dc.Ellipse(xx - s, yy - s, xx + s, yy + s);
					demoDlg->PaintDir(&dc, xx, yy, demoDlg->featuresEx->Minutiae[i].D, 10);
				}
			}

			dc.SelectObject(oldPen);
			dc.SelectObject(oldBrush);
			
			notDrawn = false;
		}
	}
	
	CStatic::OnPaint();
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// CVFingerOptions class

class CVFOptionsDlg : public CDialog // VeriFinger Options dialog
{
public:
	CVFOptionsDlg();

// Dialog Data
	enum { IDD = IDD_VFOPTIONS };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	CComboBox c_ScanMode;
	virtual BOOL OnInitDialog();
	afx_msg void OnCbnSelchangeComboMode();
	afx_msg void OnBnClickedStaticFeaturesExtraction();
	CComboBox c_FGThreshold;							 // Option Controls 
	CComboBox c_FMThreshold;
	CComboBox c_FGReturnedImages;
	CEdit e_FGMaximalRotation;
	CEdit e_FMMaximalRotation;
	CSliderCtrl s_FMMatchingSpeed;
protected:
	virtual void OnOK();
};

CVFOptionsDlg::CVFOptionsDlg() : CDialog(CVFOptionsDlg::IDD)
{
}

void CVFOptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_MODE, c_ScanMode);
	DDX_Control(pDX, IDC_COMBO_GENERALIZATION_THRESHOLD, c_FGThreshold);
	DDX_Control(pDX, IDC_COMBO_MATCHING_THRESHOLD, c_FMThreshold);
	DDX_Control(pDX, IDC_COMBO_RETURNED_IMAGE, c_FGReturnedImages);
	DDX_Control(pDX, IDC_EDIT_FG_MAXIMAL_ROTATION, e_FGMaximalRotation);
	DDX_Control(pDX, IDC_EDIT_FM_MAXIMAL_ROTATION, e_FMMaximalRotation);
	DDX_Control(pDX, IDC_SLIDER_MATCHING_SPEED, s_FMMatchingSpeed);
}

BEGIN_MESSAGE_MAP(CVFOptionsDlg, CDialog)
END_MESSAGE_MAP()


// CToolsDialog class
class CToolsDlg : public CDialog  // Demo options.
{
public:
	CToolsDlg();
// Dialog Data
	enum { IDD = IDC_OPTIONS };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	CButton b_CheckLowQuality;
	CButton b_CheckMinMinutia;
	CButton b_CheckPromptForInfo;				//options - controls
	CButton b_SearchForDuplicates;
	CButton b_WarnIfIdsDiffers;
	CEdit e_MinMinutiaCount;
	virtual BOOL OnInitDialog();

protected:
	virtual void OnOK();
	virtual void OnCancel();
public:
	afx_msg void OnBnClickedCheckSearchForDuplicates();
	afx_msg void OnBnClickedCheckMinMinutia();
	CButton b_AutoMatch;
	CButton b_AllResults;
};

CToolsDlg::CToolsDlg() : CDialog(CToolsDlg::IDD)
{
}

void CToolsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_LOW_QUALITY, b_CheckLowQuality);
	DDX_Control(pDX, IDC_CHECK_MIN_MINUTIA, b_CheckMinMinutia);
	DDX_Control(pDX, IDC_CHECK_PROMPT_FOR_INFO, b_CheckPromptForInfo);
	DDX_Control(pDX, IDC_CHECK_SEARCH_FOR_DUPLICATES, b_SearchForDuplicates);
	DDX_Control(pDX, IDC_CHECK_WARN_IF_IDS_DIFFERS, b_WarnIfIdsDiffers);
	DDX_Control(pDX, IDC_EDIT_MIN_MINUTIA_COUNT, e_MinMinutiaCount);
	DDX_Control(pDX, IDC_CHECK_AUTO_MATCH, b_AutoMatch);
	DDX_Control(pDX, IDC_CHECK_ALL_RESULTS, b_AllResults);
}

BEGIN_MESSAGE_MAP(CToolsDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_SEARCH_FOR_DUPLICATES, OnBnClickedCheckSearchForDuplicates)
	ON_BN_CLICKED(IDC_CHECK_MIN_MINUTIA, OnBnClickedCheckMinMinutia)
END_MESSAGE_MAP()


// CFingerIDDlg class
class CFingerIDDlg : public CDialog
{
public:
	CFingerIDDlg();
// Dialog Data
	enum { IDD = IDD_DIALOG_FINGER_ID };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	CEdit e_FingerId;
	virtual BOOL OnInitDialog();
protected:
	virtual void OnOK();
};

CFingerIDDlg::CFingerIDDlg() : CDialog(CFingerIDDlg::IDD)
{
}

void CFingerIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FINGER_ID, e_FingerId);
}

BEGIN_MESSAGE_MAP(CFingerIDDlg, CDialog)
END_MESSAGE_MAP()

// CVFDemoDlg dialog

CVFDemoDlg::CVFDemoDlg(CWnd* pParent)
	: CDialog(CVFDemoDlg::IDD, pParent)
{

	// main dialog form contructor - initialize internal variables

	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON);
	maxColor = RGB(255, 255, 255);
	minColor = RGB(0, 0, 0);
	maxColorEx = RGB(255, 255, 255);
	minColorEx = RGB(0, 200, 0);
	image = new CVFImage();
	imageEx = new CVFImage();
	featuresEx = new CVFFeatures();
	zoom = 1;
	resolution = 500;
	extracted = false;
	database = new VFDDatabase();
	registered = false;
}

void CVFDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_IMAGE, s_Image);
	DDX_Control(pDX, IDC_EDIT_MAIN_LOG, e_MainLog);
	DDX_Control(pDX, IDC_EDIT_SCANNER_LOG, e_ScannerLog);
	DDX_Control(pDX, IDC_BUTTON_START, b_StartStop);
	DDX_Control(pDX, IDC_BUTTON_EXTRACT, b_Extract);
	DDX_Control(pDX, IDC_STATIC_IMAGE_EX, s_ImageExt);
	DDX_Control(pDX, IDC_LIST_RESULTS, l_IdentResults);
}

BEGIN_MESSAGE_MAP(CVFDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_TOOLS_OPTIONS, OnToolsOptions)
	ON_COMMAND(ID_TOOLS_VERIFINGEROPTIONS, OnToolsVerifingeroptions)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_VIEW_ZOOMIN, OnViewZoomin)
	ON_COMMAND(ID_VIEW_ZOOMOUT, OnViewZoomOut)
	ON_COMMAND(ID_VIEW_ZOOM1, OnViewZoom1)
	ON_COMMAND(ID_TOOLS_CLEARMAINLOG, OnToolsClearmainlog)
	ON_COMMAND(ID_TOOLS_CLEARSCANNERLOG, OnToolsClearscannerlog)
	ON_BN_CLICKED(IDC_BUTTON_START, OnBnClickedButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_EXTRACT, OnBnClickedButtonExtract)
	ON_COMMAND(ID_FILE_SAVE32772, OnFileSave32772)
	ON_COMMAND(ID_Save_processed_image, OnSaveprocessedimage)
	ON_COMMAND(ID_TOOLS_CLEARDATABASE, OnToolsCleardatabase)
END_MESSAGE_MAP()


// CVFDemoDlg message handlers

CVFDemoDlg::~CVFDemoDlg (){

	// main dialog form destructor - delete and uninitialize variables

	delete image;
	delete imageEx;
	delete featuresEx;
	delete database;
	delete edOptions;
	delete vfOptions;
	delete scannerIds;
	delete pMenu;
	context= NULL;
}

BOOL CVFDemoDlg::OnInitDialog() // Initializing main dialog form
{
	CDialog::OnInitDialog();

	pMenu = new CMenu();
	pMenu->LoadMenu(IDR_MENU); 
	ASSERT(&pMenu);
	SetMenu(pMenu); // attaches menu
	isBitmap  = false;
	started = false;
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	this->edOptions = new VFDemoOptions();
	this->vfOptions = new VFingerOptions();



	HRESULT hResult;
	BOOL bSuccess;

	VFInitialize();
	this->context = VFCreateContext();

	MSXML2::IXMLDOMDocumentPtr spXMLDOM;
	hResult = CoInitialize(NULL);

	hResult = spXMLDOM.CreateInstance(__uuidof(MSXML2::DOMDocument)); // Creates XML Document
	if (FAILED(hResult)) AfxMessageBox("Unable to create XML parser object");
	if (!(bool)spXMLDOM) AfxMessageBox("Unable to create XML parser object");

	//

	InitializeDefaultVFDemoOptions(this->edOptions); // Set options to default
	bSuccess = LoadVFDemoOptions(this->edOptions,spXMLDOM); // Try to set Enrollment options from file

	InitializeDefaultVFOptions(this->vfOptions); // Set VeriFinger options to default
	bSuccess = LoadVFOptions(this->vfOptions,spXMLDOM); // Try to set VeriFinger options from file


	if (VFRegistrationType() == VF_RT_UNREGISTERED ) 
	{ // if not registered
 			AfxMessageBox("Please register VeriFinger before using it!");
			registered = false;
	} else 
	{
		registered = true;
	}
	
	spXMLDOM.Release();
	int i;

	// sets VeriFinger variables ...

	VFSetParameter(VFP_RETURNED_IMAGE,vfOptions->c_FGReturnedImages_ ,context);
	i = VFFARToMatchingThreshold(vfOptions->c_FGThreshold_);
	VFSetParameter(VFP_GENERALIZATION_THRESHOLD,i,context);
	i = VFFARToMatchingThreshold(vfOptions->c_FMThreshold_);
	VFSetParameter(VFP_MATCHING_THRESHOLD,i,context);
	VFSetParameter(VFP_MODE,vfOptions->c_ScanMode_ ,context);
	VFSetParameter(VFP_GEN_MAXIMAL_ROTATION,vfOptions->e_FGMaximalRotation_ ,context);
	VFSetParameter(VFP_MAXIMAL_ROTATION,vfOptions->e_FMMaximalRotation_ ,context);
	VFSetParameter(VFP_MATCHING_SPEED,vfOptions->s_FMMatchingSpeed_ ,context);



	SMInitialize(); // Scanman library initializing

	int scannerCount = SMGetScannerCount() ;
	this->scannerIds = new CStringArray();
	if (scannerCount == 0) {
		log.Format("No scanner found plugged in your computer"); 
		WriteLine(&e_ScannerLog, log);
		return false;
	}

	
	log.Format("Application has found %d scanner(s) plugged in your computer", scannerCount);
	WriteLine(&e_ScannerLog, log);

	CHAR * buffer;
	for (i = 0; i < scannerCount;i++) {
		INT len = SMGetScannerId(i, NULL, 0);
		buffer = new CHAR[len];
		if ( SMGetScannerId(i,buffer,len) > SME_OK) {	// adding scanners in scanner IDs array
			this->scannerIds->Add(CString(buffer));
		}
	}

	delete[] buffer;

	this->l_IdentResults.InsertColumn(1,"G",LVCFMT_CENTER,30);
	this->l_IdentResults.InsertColumn(2,"Result",LVCFMT_LEFT,50); 
	this->l_IdentResults.InsertColumn(3,"Similarity",LVCFMT_LEFT,60);	// adding columns to identification results report listview
	this->l_IdentResults.InsertColumn(4,"Record",LVCFMT_CENTER,70);
	this->l_IdentResults.InsertColumn(5,"Finger ID",LVCFMT_LEFT,250);

	return TRUE;  
}


void CVFDemoDlg::StartAllCapturing() {

	CString provider("Microsoft.Jet.OLEDB.4.0");
	CString dataSource("VFDemo.mdb");
	CString user("");
	CString password("");

	database->Open(provider,dataSource,user,password);  // opening fingerprint database, exception, if file not found

	if (database->Count == 0) {
		log.Format("Database is empty");
	} else {
		log.Format("%d record(s) from database has been loaded.",database->Count);
	}

	WriteLine(&e_MainLog,log);

	for (int i  = 0; i < this->scannerIds->GetSize(); i++) {
		log.Format("Starting capturing scanner %s : %s ",scannerIds->GetAt(i),
		SMResultToString(SMStartCapturing(scannerIds->GetAt(i), this->SMImageProc, SMStateProc, this))); // Starting capturing
		WriteLine(&this->e_ScannerLog,log);
	}
}

void CVFDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		 if (nID == SC_CLOSE ) // if closing  application    
		 {
			SMStopAllCapturingAndExit();
		 }
		CDialog::OnSysCommand(nID, lParam);
	}
}


void CVFDemoDlg::SMStopAllCapturingAndExit() { // stopping all capturing and uninitialize context and 


			CString log;
			for (int i  = 0; i < this->scannerIds->GetSize(); i++) {
				log.Format("Stopping capturing of scanner %s : %s",this->scannerIds->GetAt(i),SMResultToString(SMStopCapturing(this->scannerIds->GetAt(i)))); // Stops all capturing
				WriteLine(&this->e_ScannerLog,log);
			}
			SMFinalize(); // closing scanman library
			VFFreeContext(this->context);
			if (database->Opened()) {
				database->Close();	 // closing database (if opened)
			}
			VFFinalize();
			CoUninitialize();
}

void CVFDemoDlg::SMStopAllCapturing() { // Stopping all scanners capturing and clear some controls.

			OnToolsClearmainlog();
			l_IdentResults.DeleteAllItems();
			CString log;
			for (int i  = 0; i < this->scannerIds->GetSize(); i++) {
				log.Format("Stopping capturing of scanner %s : %s",this->scannerIds->GetAt(i),SMResultToString(SMStopCapturing(this->scannerIds->GetAt(i))));
				WriteLine(&this->e_ScannerLog,log);
			}
}

void CVFDemoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CRect rect;
	int x,y;
	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);

		GetClientRect(&rect);
		x = (rect.Width() - cxIcon + 1) / 2;
		y = (rect.Height() - cyIcon + 1) / 2;
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

	}
}


HCURSOR CVFDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVFDemoDlg::OnToolsOptions() // when menu tools/options is pressed
{
	CToolsDlg toolsDlg;

	INT_PTR nResponse = toolsDlg.DoModal(); // show options 
	if (nResponse == IDOK)
	{
		UpdateData(TRUE);
	}
	else if (nResponse == IDCANCEL)
	{
		UpdateData(FALSE);
	}
	
}


BOOL CToolsDlg::OnInitDialog() // initialize options dialog
{
	char buffer[16];
	CDialog::OnInitDialog();
	CVFDemoDlg*  vfdemodlg = (CVFDemoDlg*)this->GetParent();
	this->b_CheckLowQuality.SetCheck(vfdemodlg->edOptions->b_CheckLowQuality_);
	this->b_CheckMinMinutia.SetCheck(vfdemodlg->edOptions->b_CheckMinMinutia_);
	this->b_CheckPromptForInfo.SetCheck(vfdemodlg->edOptions->b_CheckPromptForInfo_);
	this->b_SearchForDuplicates.SetCheck(vfdemodlg->edOptions->b_SearchForDuplicates_);
	this->b_WarnIfIdsDiffers.SetCheck(vfdemodlg->edOptions->b_WarnIfIdsDiffers_);
	this->b_AutoMatch.SetCheck(vfdemodlg->edOptions->b_AutoMatch_);
	this->b_AllResults.SetCheck(vfdemodlg->edOptions->b_AllResults_);
	this->e_MinMinutiaCount.SetWindowText((LPCTSTR)itoa(vfdemodlg->edOptions->e_MinMinutiaCount_,buffer,10));
	CToolsDlg::OnBnClickedCheckSearchForDuplicates();
	return TRUE;  
}

int GetComboIndexByDataInt (CComboBox &combo, int data) {
	for (int i=1;i < combo.GetCount()+1;i++) {
		if (data == combo.GetItemData(i)) {		// working with combobox
			return i;
		}
	}
	return 0;
}

int GetComboIndexByDataDouble (CComboBox &combo, double data) {
	for (int i=1;i < combo.GetCount()+1;i++) {
		if (data == combo.GetItemData(i)) {	// the same
			return i;
		}
	}
	return 0;
}


BOOL CVFOptionsDlg::OnInitDialog() // initialize verifinger options dialog
{
	CDialog::OnInitDialog(); 

	CVFDemoDlg*  vfdemodlg = (CVFDemoDlg*)this->GetParent();
	this->c_ScanMode.InsertString( 1,"General" );
	this->c_ScanMode.SetItemData(1,VF_MODE_GENERAL);
	this->c_ScanMode.InsertString(2, "DigitalPerson U.are.U" );
	this->c_ScanMode.SetItemData(2,VF_MODE_DIGITALPERSONA_UAREU);
	this->c_ScanMode.InsertString(3, "BiometriKa FX-2000" );
	this->c_ScanMode.SetItemData(3,VF_MODE_BIOMETRIKA_FX2000);
	this->c_ScanMode.InsertString(4, "Keytronic SourceDesktop" );
	this->c_ScanMode.SetItemData(4,VF_MODE_KEYTRONIC_SECUREDESKTOP);
	this->c_ScanMode.InsertString(5, "Identix TouchView" );
	this->c_ScanMode.SetItemData(5,VF_MODE_IDENTIX_TOUCHVIEW);
	this->c_ScanMode.InsertString(6, "PreciseBiometrics 100CS" );
	this->c_ScanMode.SetItemData(6,VF_MODE_PRECISEBIOMETRICS_100CS);
	this->c_ScanMode.InsertString(7, "STMicroElectronics TouchChip" );
	this->c_ScanMode.SetItemData(7,VF_MODE_STMICROELECTRONICS_TOUCHCHIP);
	this->c_ScanMode.InsertString(8, "Identicator Technology DF-90" );
	this->c_ScanMode.SetItemData(8,VF_MODE_IDENTICATORTECHNOLOGY_DF90);
	this->c_ScanMode.InsertString(9, "Authentec AF-S2" );
	this->c_ScanMode.SetItemData(9,VF_MODE_AUTHENTEC_AFS2);
	this->c_ScanMode.InsertString(10, "Authentec AES-4000" );
	this->c_ScanMode.SetItemData(10,VF_MODE_AUTHENTEC_AES4000);
	this->c_ScanMode.InsertString(11, "Atmel FingerChip" );
	this->c_ScanMode.SetItemData(11,VF_MODE_ATMEL_FINGERCHIP);
	this->c_ScanMode.InsertString(12, "BMF BLP-100" );
	this->c_ScanMode.SetItemData(12,VF_MODE_BMF_BLP100);
	this->c_ScanMode.InsertString(13, "Secugen Hamster" );
	this->c_ScanMode.SetItemData(13,VF_MODE_SECUGEN_HAMSTER);
	this->c_ScanMode.InsertString(14, "Ethentica" );
	this->c_ScanMode.SetItemData(14,VF_MODE_ETHENTICA);
	this->c_ScanMode.InsertString(15, "CrossMatch Verifier 300" );
	this->c_ScanMode.SetItemData(15,VF_MODE_CROSSMATCH_VERIFIER300);

	this->c_FGReturnedImages.InsertString(0,"None");
	this->c_FGReturnedImages.SetItemData(0,VF_RETURNED_IMAGE_NONE);
	this->c_FGReturnedImages.InsertString(1,"Binarized");
	this->c_FGReturnedImages.SetItemData(1,VF_RETURNED_IMAGE_BINARIZED);
	this->c_FGReturnedImages.InsertString(2,"Skeletonized");
	this->c_FGReturnedImages.SetItemData(2,VF_RETURNED_IMAGE_SKELETONIZED);

	this->c_FGThreshold.InsertString(1,"0.1%");
	this->c_FGThreshold.SetItemData(1,10);
	this->c_FGThreshold.InsertString(2,"0.01%");
	this->c_FGThreshold.SetItemData(2,100);
	this->c_FGThreshold.InsertString(3,"0.001%");
	this->c_FGThreshold.SetItemData(3,1000);

	this->c_FMThreshold.InsertString(1,"0.1%");
	this->c_FMThreshold.SetItemData(1,10);
	this->c_FMThreshold.InsertString(2,"0.01%");
	this->c_FMThreshold.SetItemData(2,100);
	this->c_FMThreshold.InsertString(3,"0.001%");
	this->c_FMThreshold.SetItemData(3,1000);
	
	int result;
	this->c_ScanMode.SetCurSel(GetComboIndexByDataInt(this->c_ScanMode,vfdemodlg->vfOptions->c_ScanMode_));
	this->c_FGReturnedImages.SetCurSel(GetComboIndexByDataInt(this->c_FGReturnedImages,vfdemodlg->vfOptions->c_FGReturnedImages_));
	if (vfdemodlg->vfOptions->c_FGThreshold_ > 0 ) {
		result = (int)(1/vfdemodlg->vfOptions->c_FGThreshold_);
	} else {
		result = 0;
	}
	this->c_FGThreshold.SetCurSel(GetComboIndexByDataInt(this->c_FGThreshold,result));
	if (vfdemodlg->vfOptions->c_FGThreshold_ > 0 ) {
		result = (int)(1/vfdemodlg->vfOptions->c_FMThreshold_);
	} else {
		result = 0;
	}
	this->c_FMThreshold.SetCurSel(GetComboIndexByDataInt(c_FMThreshold,result));

	this->s_FMMatchingSpeed.SetRange(0,1,TRUE);
	char buffer[16];
	this->e_FGMaximalRotation.SetWindowText(CString(itoa(vfdemodlg->vfOptions->e_FGMaximalRotation_,buffer,10)));
	this->e_FMMaximalRotation.SetWindowText(CString(itoa(vfdemodlg->vfOptions->e_FMMaximalRotation_,buffer,10)));
	if (vfdemodlg->vfOptions->s_FMMatchingSpeed_ == VF_MATCHING_SPEED_LOW) {
		this ->s_FMMatchingSpeed.SetPos(0);
	} else {
		this ->s_FMMatchingSpeed.SetPos(1);
	}

	return TRUE;  
}

void CVFDemoDlg::OnToolsVerifingeroptions() // opens verifinger options dialog 
{
	CVFOptionsDlg vfOptionsDlg;

	INT_PTR nResponse = vfOptionsDlg.DoModal();
	if (nResponse == IDOK)
	{
		UpdateData(TRUE);
	}
	else if (nResponse == IDCANCEL)
	{
		UpdateData(FALSE);
	}
}

void CVFDemoDlg::OnScannerImage(const CString scannerId, int width, int height, const BYTE * image, int resolution) // image from scanner
{
	isBitmap = false;
	this->scannerId = scannerId;
	this->resolution = resolution;
	this->image->Assign(width, height, image);
	FreeBitmapEx();
	s_ImageExt.Invalidate();
	Invalidate();
	UpdateImage();
	extracted = false;
	isBitmap = true;
}

void CVFDemoDlg::OnScannerState(const CString scannerId, DWORD state)
{
	log.Format(SMStateToString(state, scannerId));
	WriteLine(&e_ScannerLog,log);
}

void CVFDemoDlg::OnSMMonitor(const CString & scannerId, DWORD event)
{
	log.Format(SMEventToString(event, scannerId));
	WriteLine(&e_ScannerLog,log);
}

CString CVFDemoDlg::SMEventToString(DWORD event, const CString &scannerId)
{
	CString s;
	CHAR* buffer  = new CHAR[128];
	switch(event)
	{
		case SM_EVENT_PLUGGED: s = CString("Plugged"); break;
		case SM_EVENT_UNPLUGGED: s = CString("Unplugged"); break;
		case SM_EVENT_ERROR: s = CString("Error"); break;
		default: s = CString(itoa(event,buffer,10));
	}
	delete buffer;
	return scannerId.IsEmpty() ? s : s + CString(": ") + scannerId;
}

CString CVFDemoDlg::SMStateToString(DWORD state, const CString &scannerId)
{
	CString s;
	switch(state)
	{
		case SM_STATE_FINGER_DOWN: return scannerId.IsEmpty() ? CString("Finger down") : CString("Finger placed onto ") + scannerId;
		case SM_STATE_FINGER_UP: return scannerId.IsEmpty() ? CString("Finger up") : CString("Finger removed from ") + scannerId;
		default: CHAR* buffer  = new CHAR[16]; s =  CString(itoa(state,buffer,10)) + (scannerId.IsEmpty() ? CString("") : CString(" on ") + scannerId); delete buffer; return s;
	}
}

BOOL SynchronizeToolsOptions(CToolsDlg* optionsDlg) { // validate and synchronize options  (after options dialog's pressed OK button )
	CString buffer;
	CVFDemoDlg*  vfdemodlg = (CVFDemoDlg*)optionsDlg->GetParent();
	vfdemodlg->edOptions->b_CheckLowQuality_ = optionsDlg->b_CheckLowQuality.GetCheck();
	vfdemodlg->edOptions->b_CheckMinMinutia_ = optionsDlg->b_CheckMinMinutia.GetCheck();
	vfdemodlg->edOptions->b_CheckPromptForInfo_ = optionsDlg->b_CheckPromptForInfo.GetCheck();
	vfdemodlg->edOptions->b_SearchForDuplicates_ = optionsDlg->b_SearchForDuplicates.GetCheck();
	vfdemodlg->edOptions->b_WarnIfIdsDiffers_ = optionsDlg->b_WarnIfIdsDiffers.GetCheck();
	vfdemodlg->edOptions->b_AutoMatch_ = optionsDlg->b_AutoMatch.GetCheck();
	vfdemodlg->edOptions->b_AllResults_ = optionsDlg->b_AllResults.GetCheck();
	optionsDlg->e_MinMinutiaCount.GetWindowText(buffer);
	if (!((vfdemodlg->edOptions->e_MinMinutiaCount_ = atoi(buffer)) && atoi(buffer) > 0 && atoi(buffer) < 1024))
	{
		AfxMessageBox("Minimal minutia count must be number and between 1 and 1024");
		return false;
	}
	return true;
}

void CToolsDlg::OnOK()
{
	if (SynchronizeToolsOptions(this)) {
		SaveToolsOptions((CVFDemoDlg*)this->GetParent());
		UpdateData(TRUE);
		CDialog::OnOK();
	}
}


BOOL SynchronizeVFingerOptions(CVFOptionsDlg* vfOptionsDlg) { // validate and synchronize verifinger options  (after options dialog's pressed OK button ), setting verifinger parameters
	CString buffer;
	int i;
	CVFDemoDlg* vfdemodlg = (CVFDemoDlg*) vfOptionsDlg->GetParent();
	vfdemodlg->vfOptions->c_FGReturnedImages_ = (int)vfOptionsDlg->c_FGReturnedImages.GetItemData(vfOptionsDlg->c_FGReturnedImages.GetCurSel());
	VFSetParameter(VFP_RETURNED_IMAGE,vfdemodlg->vfOptions->c_FGReturnedImages_,vfdemodlg->context);

	if (vfOptionsDlg->c_FGThreshold.GetItemData(vfOptionsDlg->c_FGThreshold.GetCurSel()) > 0 ) {
		vfdemodlg->vfOptions->c_FGThreshold_ = (double)1/(double)(vfOptionsDlg->c_FGThreshold.GetItemData(vfOptionsDlg->c_FGThreshold.GetCurSel()));
	} else {
		AfxMessageBox("Feature generalization threshold must be selected");
		return false;
	}

	i = VFFARToMatchingThreshold(vfdemodlg->vfOptions->c_FGThreshold_);
	VFSetParameter(VFP_GENERALIZATION_THRESHOLD,i,vfdemodlg->context);


	if(vfOptionsDlg->c_FMThreshold.GetItemData(vfOptionsDlg->c_FMThreshold.GetCurSel()) > 0 ) {
		vfdemodlg->vfOptions->c_FMThreshold_ = (double)1/(double)(vfOptionsDlg->c_FMThreshold.GetItemData(vfOptionsDlg->c_FMThreshold.GetCurSel()));
	} else {
		AfxMessageBox("Feature generalization threshold must be selected");
		return false;
	}

	i = VFFARToMatchingThreshold(vfdemodlg->vfOptions->c_FMThreshold_);
	VFSetParameter(VFP_MATCHING_THRESHOLD,i,vfdemodlg->context);

	vfdemodlg->vfOptions->c_ScanMode_ = (int)vfOptionsDlg->c_ScanMode.GetItemData(vfOptionsDlg->c_ScanMode.GetCurSel());
	VFSetParameter(VFP_MODE,vfdemodlg->vfOptions->c_ScanMode_,vfdemodlg->context);
	
	vfOptionsDlg->e_FGMaximalRotation.GetWindowText(buffer);
	if (!((vfdemodlg->vfOptions->e_FGMaximalRotation_ = atoi(buffer)) && atoi(buffer) > 0 && atoi(buffer) < 181)){
		AfxMessageBox("Feature generaliztion maximal rotation must be number and between 1 and 180");
		return false;
	}
	VFSetParameter(VFP_GEN_MAXIMAL_ROTATION,vfdemodlg->vfOptions->e_FGMaximalRotation_,vfdemodlg->context);
	

	vfOptionsDlg->e_FMMaximalRotation.GetWindowText(buffer);
	if (!((vfdemodlg->vfOptions->e_FMMaximalRotation_ = atoi(buffer)) && atoi(buffer) > 0 && atoi(buffer) < 181)){
		AfxMessageBox("Maximal rotation must be number and between 1 and 180");
		return false;
	}
	VFSetParameter(VFP_MAXIMAL_ROTATION,vfdemodlg->vfOptions->e_FGMaximalRotation_,vfdemodlg->context);

	if (vfOptionsDlg->s_FMMatchingSpeed.GetPos() == 0) {
		vfdemodlg->vfOptions->s_FMMatchingSpeed_ = VF_MATCHING_SPEED_LOW;
	} else {
		vfdemodlg->vfOptions->s_FMMatchingSpeed_ = VF_MATCHING_SPEED_HIGH;
	}
	VFSetParameter(VFP_MATCHING_SPEED,vfdemodlg->vfOptions->s_FMMatchingSpeed_,vfdemodlg->context);
	return true;
}

BOOL SaveToolsOptions(CVFDemoDlg* demoDlg){ // saving options to XML file

 VARIANT_BOOL bSuccess = false;
 HRESULT hResult;
 MSXML2::IXMLDOMDocumentPtr spXMLDOM;
 hResult = CoInitialize(NULL);
 char buffer[15];

 hResult = spXMLDOM.CreateInstance(__uuidof(MSXML2::DOMDocument));
 if (FAILED(hResult)) AfxMessageBox( "Unable to create XML parser object");
 if (!(bool)spXMLDOM) AfxMessageBox(  "Unable to create XML parser object");

 bSuccess = spXMLDOM->load(_bstr_t(L"VFDemo.MFC.settings"));
 if (!bSuccess)  { AfxMessageBox ("Unable to load XML document into the parser"); return false; }

 _bstr_t bstrSS(L"VFDemo");
 _bstr_t bstrSSo(L"VFDemo/Options");
 MSXML2::IXMLDOMNodePtr spXMLNode;
 MSXML2::IXMLDOMNodePtr spXMLNodeO;
 MSXML2::IXMLDOMNodePtr spXMLChildNode;
 MSXML2::IXMLDOMElementPtr spXMLChildElem;
 MSXML2::IXMLDOMNodePtr spInsertedNode;
 MSXML2::IXMLDOMElementPtr spXMLChildElement;

 spXMLNode = spXMLDOM->selectSingleNode(bstrSS);
 if (!(bool)spXMLNode) { AfxMessageBox( "Unable to locate 'VFDemo' node"); return false;}
 spXMLNodeO = spXMLDOM->selectSingleNode(bstrSSo);
 if((bool)spXMLNodeO) {
	hResult = spXMLNode->removeChild(spXMLNodeO);
	if (FAILED(hResult)) { AfxMessageBox ("Unable to remove 'VFDemo/Options' node");return false;}
 }
 
 spXMLChildElem = spXMLDOM->createElement(_bstr_t("Options"));
 spInsertedNode = spXMLNode->appendChild(spXMLChildElem);
 spXMLChildElement = spInsertedNode;

 spXMLChildElement->setAttribute(_bstr_t (L"CheckLowQuality"),_variant_t (itoa(demoDlg->edOptions->b_CheckLowQuality_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"CheckMinMinutia"),_variant_t (itoa(demoDlg->edOptions->b_CheckMinMinutia_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"CheckPromptForInfo"),_variant_t (itoa(demoDlg->edOptions->b_CheckPromptForInfo_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"SearchForDuplicates"),_variant_t (itoa(demoDlg->edOptions->b_SearchForDuplicates_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"WarnIfIdsDiffers"),_variant_t (itoa(demoDlg->edOptions->b_WarnIfIdsDiffers_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"AutoMatch"),_variant_t (itoa(demoDlg->edOptions->b_AutoMatch_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"AllResults"),_variant_t (itoa(demoDlg->edOptions->b_AllResults_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"MinMinutiaCount"),_variant_t(itoa(demoDlg->edOptions->e_MinMinutiaCount_,buffer,10)));
 
 hResult = spXMLDOM->save(CComVariant("VFDemo.MFC.settings"));
 if (FAILED(hResult))
 {
	AfxMessageBox("Unable to save setting file");
	return false;
 }
 return true;

}


BOOL SaveVFingerOptions(CVFDemoDlg* demoDlg){ // saving VeriFinger options to XML file

 VARIANT_BOOL bSuccess = false;
 HRESULT hResult;
 MSXML2::IXMLDOMDocumentPtr spXMLDOM;
 hResult = CoInitialize(NULL);
 char buffer[15];
 CString temp;

 hResult = spXMLDOM.CreateInstance(__uuidof(MSXML2::DOMDocument));
 if (FAILED(hResult)) AfxMessageBox( "Unable to create XML parser object");
 if (!(bool)spXMLDOM) AfxMessageBox(  "Unable to create XML parser object");

 bSuccess = spXMLDOM->load(CComVariant("VFDemo.MFC.settings"));
 if (FAILED(hResult))  { AfxMessageBox ("Unable to load XML document into the parser"); return false;}
 if (!bSuccess)  { AfxMessageBox ("Unable to load XML document into the parser"); return false; }

 _bstr_t bstrSS(L"VFDemo");
 _bstr_t bstrSSo(L"VFDemo/VFingerOptions");
 MSXML2::IXMLDOMNodePtr spXMLNode;
 MSXML2::IXMLDOMNodePtr spXMLNodeO;
 MSXML2::IXMLDOMNodePtr spXMLChildNode;
 MSXML2::IXMLDOMElementPtr spXMLChildElem;
 MSXML2::IXMLDOMNodePtr spInsertedNode;
 MSXML2::IXMLDOMElementPtr spXMLChildElement;

 spXMLNode = spXMLDOM->selectSingleNode(bstrSS);
 if (!(bool)spXMLNode) { AfxMessageBox( "Unable to locate 'VFDemo' node"); return false;}
 spXMLNodeO = spXMLDOM->selectSingleNode(bstrSSo);
 if((bool)spXMLNodeO) {
		hResult = spXMLNode->removeChild(spXMLNodeO);
 		if ( FAILED(hResult) ) { AfxMessageBox ("Unable to remove 'VFDemo/VFingerOptions' node");return false;}
 }
 spXMLChildElem = spXMLDOM->createElement(_bstr_t("VFingerOptions"));
 spInsertedNode = spXMLNode->appendChild(spXMLChildElem);
 spXMLChildElement = spInsertedNode;

 spXMLChildElement->setAttribute(_bstr_t (L"FGReturnedImages"),_variant_t (itoa(demoDlg->vfOptions->c_FGReturnedImages_,buffer,10)));
 temp.Format("%1.3f",demoDlg->vfOptions->c_FGThreshold_);
 spXMLChildElement->setAttribute(_bstr_t (L"FGThreshold"),_variant_t (temp ));
 temp.Format("%1.3f",demoDlg->vfOptions->c_FMThreshold_);
 spXMLChildElement->setAttribute(_bstr_t (L"FMThreshold"),_variant_t (temp));
 spXMLChildElement->setAttribute(_bstr_t (L"ScanMode"),_variant_t (itoa(demoDlg->vfOptions->c_ScanMode_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"FGMaximalRotation"),_variant_t (itoa(demoDlg->vfOptions->e_FGMaximalRotation_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"FMMaximalRotation"),_variant_t (itoa(demoDlg->vfOptions->e_FMMaximalRotation_,buffer,10)));
 spXMLChildElement->setAttribute(_bstr_t (L"FMMatchingSpeed"),_variant_t (itoa(demoDlg->vfOptions->s_FMMatchingSpeed_,buffer,10)));
 hResult = spXMLDOM->save(CComVariant("VFDemo.MFC.settings"));
 if (FAILED(hResult))
 {
	AfxMessageBox("Unable to save setting file");
	return false;
 }
 return true;
}

void CToolsDlg::OnCancel() // if options dialog's cancel button pressed
{
	UpdateData(FALSE);
	CDialog::OnCancel();
}

void CVFOptionsDlg::OnOK() // if verifinger option's OK button pressed
{
	if (SynchronizeVFingerOptions(this)) {
		SaveVFingerOptions((CVFDemoDlg*)this->GetParent());
		UpdateData(TRUE);
		CDialog::OnOK();
	}
}

void CToolsDlg::OnBnClickedCheckSearchForDuplicates() // enable/disable option
{
	if(this->b_SearchForDuplicates.GetCheck() == BST_CHECKED) {
		this->b_WarnIfIdsDiffers.EnableWindow();
	} else {
		this->b_WarnIfIdsDiffers.EnableWindow(FALSE);
	}
}

void CToolsDlg::OnBnClickedCheckMinMinutia() // enable/disable option
{
	if(this->b_CheckMinMinutia.GetCheck() == BST_CHECKED) {
		this->e_MinMinutiaCount.EnableWindow();
	} else {
		this->e_MinMinutiaCount.EnableWindow(FALSE);
	}

}

CString SMErrorToString(INT error)
{
	if(error >= 0) return "";
	switch(error)
	{
		case SME_FAILED: return TEXT("Failed");
		case SME_OUT_OF_MEMORY: return TEXT("Out of memory");
		case SME_NOT_INITIALIZED: return TEXT("Not initialized");
		case SME_ARGUMENT_NULL: return TEXT("Argument null");
		case SME_INVALID_ARGUMENT: return TEXT("Invalid argument");
		case SME_INVALID_PARAMETER: return TEXT("Invalid parameter");
		case SME_PARAMETER_READ_ONLY: return TEXT("Parameter is read only");
		case SME_ALREADY_CAPTURING: return TEXT("Already capturing");
		case SME_NOT_CAPTURING: return TEXT("Not capturing");
		default: CString temp; CHAR* buffer; buffer =  new CHAR[256]; temp = itoa(error,buffer,10); delete buffer; return temp;
	}
}

CString SMResultToString(INT result)
{
	if(SMFailed(result)) return SMErrorToString(result);
	else return result == SME_OK ? CString("OK") : CString("OK (%d)", result);
}

void CVFDemoDlg::OnFileExit()
{
	SMStopAllCapturingAndExit();
	this->EndDialog(IDCLOSE);
}

void CVFDemoDlg::UpdateImage() // update left "view"
{
	FreeBitmap();
	canExtract = false;
	this->b_Extract.EnableWindow(canExtract);
	if(image)
	{
		bitmap = image->GetBitmap(image->Width()*zoom,image->Height()*zoom,minColor, maxColor);
		bitmapWidth = image->Width();
		bitmapHeight = image->Height();
		OnImagePaint();
	}
}

void CVFDemoDlg::UpdateImageEx() // update right "view"
{
	FreeBitmapEx();
	if(imageEx)
	{
		bitmapEx = imageEx->GetBitmap(imageEx->Width()*zoom,imageEx->Height()*zoom,minColorEx, maxColorEx);
		bitmapWidthEx = imageEx->Width();
		bitmapHeightEx = imageEx->Height();
		OnImagePaintEx();
	}
}

void WriteLine(CEdit* editControl, CString text){ // Writes line in control (edit)
 CString temporary;
 CString log;
 editControl->GetWindowText(temporary);
 if (temporary != "") {
	log.Format("%s\r\n%s",temporary,text);
 } else {
    log.Format(text);
 }
 editControl->HideCaret();
 editControl->SetWindowText(log);
 editControl->LineScroll(editControl->GetLineCount());

}

void CVFDemoDlg::OnImagePaint()
{
	s_Image.SetBitmap(bitmap);
	s_Image.Invalidate();
	log.Format("Image from scanner %s :\r\n size %dx%d, resolution:%d dpi",scannerId,bitmapWidth,bitmapHeight,resolution);
	WriteLine(&e_MainLog,log);
	Invalidate();
	canExtract = true;
	this->b_Extract.EnableWindow(canExtract);
}

void CVFDemoDlg::FreeBitmap()
{
	if (bitmap)
	{
		DeleteObject(bitmap);
		bitmap = NULL;
		bitmapWidth = 0;
		bitmapHeight = 0;
	}
}

void CVFDemoDlg::OnImagePaintEx() // When drawing image in right "view"
{
	extracted = true;
	s_ImageExt.notDrawn  = true;
	s_ImageExt.RedrawWindow();
}

void CVFDemoDlg::PaintDir(CPaintDC* dc, int x, int y, BYTE dir, int length) // paint minutiae directions
{
	int len = FeatToLocal(length);
	double a = VFDirToRad(dir);
	int dx = Round(cos(a) * len);
	int dy = Round(sin(a) * len);
	dc->MoveTo(x, y);
	dc->LineTo(x + dx, y + dy);
}

void CVFDemoDlg::FreeBitmapEx()
{
	if (bitmapEx)
	{
		DeleteObject(bitmapEx);
		bitmapEx = NULL;
		bitmapWidthEx = 0;
		bitmapHeightEx = 0;
	}
}

void CVFDemoDlg::OnViewZoomin() // when zoomed in
{
	if (isBitmap && zoom < 3) {
		zoom++;
		UpdateImage();
		UpdateImageEx();
	}
}

void CVFDemoDlg::OnViewZoomOut() // when zoomed out
{
	if (isBitmap && zoom > 1) {
		zoom--;
		UpdateImage();
		UpdateImageEx();
	}
}

void CVFDemoDlg::OnViewZoom1()
{
	if (isBitmap && zoom > 1) {
		zoom = 1;
		UpdateImage();
		UpdateImageEx();
	}
}


void CVFDemoDlg::OnToolsClearmainlog() // clear main log
{
	this->e_MainLog.SetWindowText("");
}

void CVFDemoDlg::OnToolsClearscannerlog() // clear scanner log
{
	this->e_ScannerLog.SetWindowText("");
}

void CVFDemoDlg::OnBnClickedButtonStart() // Start/stop capturing button pressed
{
	if (started){
		SMStopAllCapturing();
		b_StartStop.SetWindowText("Start capturing");
		started = false;
		canExtract = false;
		b_Extract.EnableWindow(canExtract);
	} else {
		StartAllCapturing();
		b_StartStop.SetWindowText("Stop capturing");
		started = true;
	}
}

BOOL CVFDemoDlg::Extract() { // Extract

	imageEx->Assign(image);
	DWORD tc = GetTickCount();
	result = VFExtract(image->Width(), image->Height(), imageEx->Bits(), resolution, features, &featuresSize, context);

	time = GetTickCount() - tc;
	if (VFSucceeded(result) || result == VFE_LOW_QUALITY_IMAGE)
	{
		log.Format("Extraction complete: %s. Time: %d ms.", (LPCTSTR)VFResultToString(result),time);
		WriteLine(&e_MainLog,log);
		result = result != VFE_LOW_QUALITY_IMAGE || this->edOptions->b_CheckLowQuality_;
		featuresEx->SetData(features, featuresSize);
		// show output
		resolutionEx = resolution;
		if (this->edOptions->b_CheckMinMinutia_ && featuresEx->Minutiae.GetSize() < this->edOptions->e_MinMinutiaCount_) {
			log.Format("Minutia count (%d) is less than minimal accepted value (%d)",featuresEx->Minutiae.GetSize(),this->edOptions->e_MinMinutiaCount_);
			AfxMessageBox(log);
			return false;
		}
	}
	else
	{
		s_ImageExt.SetBitmap(NULL);
		s_ImageExt.RedrawWindow();
		log.Format("Extraction error: %s. Futher processing not performed", VFErrorToString(result));
		WriteLine(&e_MainLog,log);
		log.Format("Extraction error: %s", VFErrorToString(result));
		AfxMessageBox(log);
		return false;
	}
	OnExtract();
	return true;
}

void CVFDemoDlg::OnBnClickedButtonExtract() // when extract button pressed
{

	if (Extract()) UpdateImageEx();
}

int CVFDemoDlg::SearchForDuplicates() { // searches for duplicates
		int result = VFIdentifyStart(features, NULL);
		int index= -1, similarity = 0;
		if (VFSucceeded(result))
		{
			VFDBFindData fd;
			database->FindStart(features, fd);
			int c = database->Count;
			int count_threshold = c, count = 0;
			VFMatchDetails md;
			md.Size = sizeof(md);
			bool stop = false;
			int i = 0;
			do
			{
				i = database->FindNext(fd);
				if (i == -1 || count > count_threshold) i = c;
				if (i < c)
				{
					result = VFIdentifyNext(database->Features(i), &md, NULL);
					if (VFSucceeded(result))
					{
						if (edOptions->b_WarnIfIdsDiffers_) {
							if(this->fingerID != database->FingerID(i)) {
								index = i;
								stop = true;
							}
						} else {
							index = i;
							stop = true;
						}
					}
					count++;
				}
				else stop = true;
			} while (!stop && count < c);
			result = VFIdentifyEnd(NULL);
			database->FindEnd(fd);
			if (VFSucceeded(result)) { return index; } else { return VFE_FAILED;	};
		}

		return 0;
}


int CVFDemoDlg::ListResults() { // show identification results
		int result = VFIdentifyStart(features, NULL);
		int index= -1, similarity = 0;
		CHAR buffer[16];
		if(VFSucceeded(result))
		{
			VFDBFindData fd;
			database->FindStart(features, fd);
			int c = database->Count;
			int count_threshold = c, count = 0;
			VFMatchDetails md;
			md.Size = sizeof(md);
			int i = -1;
			DWORD dt = GetTickCount();
			if(!this->l_IdentResults.DeleteAllItems()) return -1;
			do
			{
				result = VFIdentifyNext(database->Features(count), &md, NULL);
					if((edOptions->b_AllResults_ == 0 && VFSucceeded(result)) || edOptions->b_AllResults_ == BST_CHECKED) {
						int k = this->l_IdentResults.InsertItem(LVIF_TEXT,1,itoa(VFFeatGetG(database->Features(count)),buffer,10),LVIS_STATEIMAGEMASK,0,NULL,NULL);
						l_IdentResults.SetItemData(k,md.Similarity);
						this->l_IdentResults.SetItemText(k,1,VFResultToString(result));
						this->l_IdentResults.SetItemText(k,2,itoa(md.Similarity,buffer,10));
						this->l_IdentResults.SetItemText(k,3,itoa(database->ID(count),buffer,10));
						this->l_IdentResults.SetItemText(k,4,database->FingerID(count));
					}

				//}
				count++;
			} while(count < c);
			result = VFIdentifyEnd(NULL);
			if(VFSucceeded(result)) result = index == -1 ? VFE_FAILED : VFE_OK;
		}
		l_IdentResults.SortItems(ResultCompare,(LPARAM)&l_IdentResults);
		return (DWORD)result;
}


void CVFDemoDlg::OnExtract() { // after extract searches for duplicates and show identification results
	int index;
	CFingerIDDlg getFingerID; 

	INT_PTR result = getFingerID.DoModal();
	if (result == IDOK) {

		if(edOptions->b_SearchForDuplicates_ == BST_CHECKED && database->Count > 0)
		{	

			index = SearchForDuplicates();
	

			WriteLine(&e_MainLog,"Searching for duplicates");
			 
			if(index != -1)
			{
				CString dupFingerId = database->FingerID(index);
				if(edOptions->b_WarnIfIdsDiffers_ == BST_CHECKED  || fingerID != dupFingerId)
				{
					log.Format("Duplicate found. Finger ID: \"%s\". Record ID: %d", dupFingerId, database->ID(index));
					WriteLine(&e_MainLog,log);
					log.Format("Duplicate found. Finger ID: \"%s\". Record ID: %d\nAdd to the database?",
						(LPCTSTR)dupFingerId, database->ID(index));
					if(AfxMessageBox(log,MB_YESNO) == IDNO) {index = ListResults();return;}
				}
			}
		}
		if(database->Count > 0)	index = ListResults();
		if(database->Add(this->features, this->featuresSize,(LPCTSTR)fingerID) >= 0 ) {		
			log.Format("Fingerprint ID:\"%s\" added to database.",fingerID);
			WriteLine(&e_MainLog,log);
			this->extracted = false;
			this->b_Extract.EnableWindow(false);
			WriteLine(&e_MainLog,"");
			WriteLine(&e_MainLog,"Waiting for image.");
			WriteLine(&e_MainLog,"");
		} else {
			log.Format("Can't add fingerprint to database.");
			WriteLine(&e_MainLog,log);
		}
	} else {
		log.Format("Fingerprint ID is empty. Fingerprint hasn't been added to database.");
		WriteLine(&e_MainLog,log);
		if(database->Count > 0) index = ListResults();
	}
}

BOOL CFingerIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CVFDemoDlg* demoDlg = (CVFDemoDlg*) this->GetParent();
	this->e_FingerId.SetWindowText(demoDlg->fingerID);
	return true;
}

void CFingerIDDlg::OnOK()
{
	CVFDemoDlg* demoDlg = (CVFDemoDlg*) this->GetParent();
	CHAR* buffer = new CHAR[50];
	this->e_FingerId.GetWindowText(buffer,50);
	demoDlg->fingerID = buffer;
	delete[] buffer;
	CDialog::OnOK();
}

const double ThFARLogRatio = 12;

double VFMatchingThresholdToFAR(INT th)
{
	if(th < 0) th = 0;
	return pow(10.0, -th / ThFARLogRatio + 2);
}

INT VFFARToMatchingThreshold(double f)
{
	if(f > 100.0) f = 100.0;
	else if(f <= 0.0) f = 1E-100;
	return Round((-log10(f) + 2) * ThFARLogRatio);
}
void CVFDemoDlg::OnFileSave32772()
{
	SaveImage(image);
}

void CVFDemoDlg::SaveImage(CVFImage* image) // saves image
{
	if(image->Width() == 0) {
		AfxMessageBox("Nothing to save");
		return;	
	}
	CFileDialog saveDialog(false,"bmp",0,NULL,"*.bmp");
	if(saveDialog.DoModal() == IDOK)
	{

		CFile saveFile;
		CFileException fileException;
		int bitmapWidth = this->image->Width()*zoom;
		int bitmapHeight= this->image->Height()*zoom;
		int width = this->image->Width();
		int height = this->image->Height();
	
		BITMAPFILEHEADER *fileHeader = (BITMAPFILEHEADER*)malloc(sizeof(BITMAPFILEHEADER));
		fileHeader->bfType = 19778;
		fileHeader->bfReserved1 = 0;
		fileHeader->bfReserved2 = 0;
		fileHeader->bfSize = 0;
		fileHeader->bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256;



		BITMAPINFO *bi = (BITMAPINFO*)malloc(sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256);
		bi->bmiHeader.biBitCount = 8;
		bi->bmiHeader.biClrImportant = 0;
		bi->bmiHeader.biClrUsed = 0;
		bi->bmiHeader.biCompression = BI_RGB;
		bi->bmiHeader.biPlanes = 1;
		bi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bi->bmiHeader.biXPelsPerMeter = 0;
		bi->bmiHeader.biYPelsPerMeter = 0;
		bi->bmiHeader.biHeight = bitmapHeight;
		bi->bmiHeader.biWidth = bitmapWidth;
		int blue_min = GetBValue(minColor);
		int green_min = GetGValue(minColor);
		int red_min = GetRValue(minColor);
		int blue_max = GetBValue(maxColor);
		int green_max = GetGValue(maxColor);
		int red_max = GetRValue(maxColor);
		int blue_delta = blue_max - blue_min;
		int green_delta = green_max - green_min;
		int red_delta = red_max - red_min;
		for(int i = 0; i < 256; i++)
		{
			bi->bmiColors[i].rgbBlue = (BYTE)(i * blue_delta / 255 + blue_min);
			bi->bmiColors[i].rgbGreen = (BYTE)(i * green_delta / 255 + green_min);
			bi->bmiColors[i].rgbRed = (BYTE)(i * red_delta / 255 + red_min);
			bi->bmiColors[i].rgbReserved = 0;
		}
		
		saveFile.Open( saveDialog.GetPathName(), CFile::modeCreate |   
			   CFile::modeWrite | CFile::typeBinary  ), &fileException;
		saveFile.Write(fileHeader,sizeof(BITMAPFILEHEADER));
		saveFile.Write(bi,sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256);

		DWORD width_bytes = (width / 4 + (width % 4 ? 1 : 0)) * 4;
		BYTE *img = image->bits + (height - 1) * width;
		for (int i = 0; i < height; i++, img -= width) {
			saveFile.Write(img,width);	
			if (width % 4 > 0 ) {
				for(int y = 0 ; y < 4 - width % 4;y++) {
					saveFile.Write(0,1);
				}
			}
		}

		
		free(bi);
		saveFile.Close();
	}

}


void CVFDemoDlg::OnSaveprocessedimage()
{
	if(this->extracted){SaveImage(imageEx);} else {AfxMessageBox("Nothing to save");};
}

void CVFDemoDlg::OnToolsCleardatabase() // clearing database
{
	if (database->Count > 0 ) {
		if (AfxMessageBox("Do you really want delete all records from database ?", MB_YESNO) == IDYES) {
			log.Format("%d record(s) was deleted from database",database->Count);
			database->Clear();
			WriteLine(&e_MainLog,log);
			return;
		}
	} else {
		AfxMessageBox("Database is empty or not opened. Nothing to clear.");
		return;
	}
}

BOOL CMyStatic::OnEraseBkgnd(CDC* pDC)
{
	return true;
}

