#pragma once

class CThread
{
private:
	bool running;
	HANDLE handle;
	DWORD id;

	static DWORD WINAPI ThreadProc(LPVOID parameter);
	DWORD Execute();

protected:
	virtual void OnStartExecute();
	virtual DWORD OnExecute() = 0;
	virtual void OnEndExecute(DWORD exitCode);

	void CheckRunning() { if(running) throw exception("Thread running"); }

public:
	CThread(bool createSuspended = true);
	virtual ~CThread();

	HANDLE get_Handle() { return handle; }
	__declspec(property(get = get_Handle)) HANDLE Handle;

	DWORD get_Id() { return id; }
	__declspec(property(get = get_Id)) DWORD Id;

	bool get_Running() { return running; }
	__declspec(property(get = get_Running)) bool Running;

	void Resume();
	void Suspend();
	void Terminate(DWORD exit_code = 0);
	void WaitFor(DWORD ms = INFINITE);

	DWORD get_ExitCode();
	__declspec(property(get = get_ExitCode)) DWORD ExitCode;
};
