/********************************************************\
|*                                                      *|
|*                  VeriFinger 4.2 SDK                  *|
|*                                                      *|
|*  VFingerX.h                                          *|
|*    Header file for extended VeriFinger features      *|
|*                                                      *|
|*  Copyright (C) 1998-2004 Neurotechnologija           *|
|*                                                      *|
\********************************************************/

#pragma once

#ifdef FINGERCELL
	#include <FingerCell.h>
	#define VF_ENGINE_NAME TEXT("FingerCell")
#else
	#include <VFinger.h>
	#define VF_ENGINE_NAME TEXT("VeriFinger")
#endif

////////////////////////////////
//                            //
// Error and result functions //
//                            //
////////////////////////////////

string VFErrorToString(INT error);
string VFResultToString(INT result);

void VFRaiseError(INT error);
void VFCheckResult(INT result);

//////////////////////////
//                      //
// Parameters functions //
//                      //
//////////////////////////

bool VFParameterOfType(INT parameter, INT type);
void VFCheckParameterType(INT parameter, INT type);

// Get
BYTE VFGetByteParameter(INT parameter, HVFCONTEXT context = NULL);
SBYTE VFGetSByteParameter(INT parameter, HVFCONTEXT context = NULL);
WORD VFGetWordParameter(INT parameter, HVFCONTEXT context = NULL);
SHORT VFGetShortParameter(INT parameter, HVFCONTEXT context = NULL);
DWORD VFGetDWordParameter(INT parameter, HVFCONTEXT context = NULL);
INT VFGetIntParameter(INT parameter, HVFCONTEXT context = NULL);
bool VFGetBoolParameter(INT parameter, HVFCONTEXT context = NULL);
TCHAR VFGetCharParameter(INT parameter, HVFCONTEXT context = NULL);
string VFGetStringParameter(INT parameter, HVFCONTEXT context = NULL);

// Set
BYTE VFSetByteParameter(INT parameter, BYTE value, HVFCONTEXT context = NULL);
SBYTE VFSetSByteParameter(INT parameter, SBYTE value, HVFCONTEXT context = NULL);
WORD VFSetWordParameter(INT parameter, WORD value, HVFCONTEXT context = NULL);
SHORT VFSetShortParameter(INT parameter, SHORT value, HVFCONTEXT context = NULL);
DWORD VFSetDWordParameter(INT parameter, DWORD value, HVFCONTEXT context = NULL);
INT VFSetIntParameter(INT parameter, INT value, HVFCONTEXT context = NULL);
bool VFSetBoolParameter(INT parameter, bool value, HVFCONTEXT context = NULL);
TCHAR VFSetCharParameter(INT parameter, TCHAR value, HVFCONTEXT context = NULL);
string VFSetStringParameter(INT parameter, const string & value, HVFCONTEXT context = NULL);

// Get general
INT VFGetParameterType(INT parameter);
string VFGetName();
DWORD VFGetVersionHigh();
DWORD VFGetVersionLow();
string VFGetCopyright();

//////////////////////////////////////////
//                                      //
// FAR and matching threshold functions //
//                                      //
//////////////////////////////////////////

double VFMatchingThresholdToFAR(INT th);
INT VFFARToMatchingThreshold(double f);
