unit FormAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, VFinger, Utils, ScanMan;

type
  TAboutForm = class(TForm)
    Image1: TImage;
    LabelApp: TLabel;
    LabelAppCopyright: TLabel;
    GroupBoxOS: TGroupBox;
    GroupBoxVF: TGroupBox;
    GroupBoxSM: TGroupBox;
    ButtonOK: TButton;
    LabelOS: TLabel;
    LabelOSSP: TLabel;
    LabelVF: TLabel;
    LabelVFCopyright: TLabel;
    LabelIsRegistered: TLabel;
    LabelSM: TLabel;
    LabelSMCopyright: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    procedure ShowVersion(Name: string; VersionHigh, VersionLow: LongWord; Copyright: string;
      LabelName, LabelCopyright: TLabel);
  end;

procedure AboutBox(Owner: TForm);

implementation

{$R *.dfm}

procedure AboutBox(Owner: TForm);
var
  Form: TAboutForm;
begin
  Form := TAboutForm.Create(Owner);
  Form.ShowModal;
  Form.Free;
end;

{ TAboutForm }

procedure TAboutForm.ShowVersion(Name: string; VersionHigh,
  VersionLow: LongWord; Copyright: string; LabelName, LabelCopyright: TLabel);
begin
  LabelName.Caption := Format('%s    Version %u.%u.%u.%u', [Name,
    HiWord(VersionHigh), LoWord(VersionHigh), HiWord(VersionLow), LoWord(VersionLow)]);
  LabelCopyright.Caption := Copyright;
end;

procedure TAboutForm.FormCreate(Sender: TObject);
begin
  ShowVersion(Application.Title, ApplicationVersionHigh, ApplicationVersionLow,
    ApplicationCopyright, LabelApp, LabelAppCopyright);
  LabelOS.Caption := Format('%s. Version %u.%u (Build %u)',
    [OSName, OSMajorVersion, OSMinorVersion, OSBuild]);
  LabelOSSP.Caption := Format('Service Pack Version %u.%u',
    [OSSPMajorVersion, OSSPMinorVersion]);
  ShowVersion(VFGetName, VFGetVersionHigh, VFGetVersionLow, VFGetCopyright,
    LabelVF, LabelVFCopyright);
  if VFRegistrationType = VF_RT_UNREGISTERED then
  begin
    LabelIsRegistered.Caption := 'Registered: No';
  end
  else begin
    LabelIsRegistered.Caption := 'Registered: Yes';
  end;
  ShowVersion(SMGetName, SMGetVersionHigh, SMGetVersionLow, SMGetCopyright,
    LabelSM, LabelSMCopyright);
end;

end.
