//#if defined(linux) || defined (__LINUX__)
//	#include "linux_include.h"
//#else
	#include "stdafx.h"
//#endif
/*
 * Class:     VeriFinger_VeriFingerWrapper
 * Method:    VFRegistrationType
 * Signature: ()I
 */

JNIEXPORT jint JNICALL Java_VeriFinger_VeriFingerWrapper_VFRegistrationType
  (JNIEnv * env, jclass)
{
    int res = VFE_OK;

    try
    {
        res = VFRegistrationType();
        if VFFailed(res) 
            ThrowVeriFingerException(env, res);
    }
    catch(...)
    {
        ThrowJavaException(env);
    }
    
    return res;
}

/*
 * Class:     VeriFinger_VeriFingerWrapper
 * Method:    VFGenerateId
 * Signature: (Ljava/lang/String;)Ljava/lang/String;
 */

JNIEXPORT jstring JNICALL Java_VeriFinger_VeriFingerWrapper_VFGenerateId
  (JNIEnv * env, jclass jcls, jstring jparam)
{
    char result[100];
    memset(result, 0, 100);

    try
    {
        const char *param = NULL;

        param = env->GetStringUTFChars(jparam, NULL); 
        if (param == NULL) 
        {
            ThrowVeriFingerException(env, VFE_INVALID_SERIAL_NUMBER);
            return env->NewStringUTF(result);
        }

        int res = VFGenerateId((char *)param, result);

        if VFFailed(res)
            ThrowVeriFingerException(env, res);
        
        env->ReleaseStringUTFChars(jparam, param);
    }
    catch(...)
    {
        ThrowJavaException(env);
    }

    return env->NewStringUTF(result);
}

/*
 * Class:     VeriFinger_VeriFingerWrapper
 * Method:    VFRegister
 * Signature: (Ljava/lang/String;Ljava/lang/String;)V
 */

JNIEXPORT void JNICALL Java_VeriFinger_VeriFingerWrapper_VFRegister
  (JNIEnv * env, jclass, jstring jserial, jstring jkey)
{
    try
    {
        
        const char *key = NULL;
        const char *serial = NULL;

        key = env->GetStringUTFChars(jkey, NULL);         
        
        if (key == NULL) 
        {
            ThrowVeriFingerException(env, VFE_INVALID_REGISTRATION_KEY);
            return;
        }

        serial = env->GetStringUTFChars(jserial, NULL); 
        if (serial == NULL) 
        {
            env->ReleaseStringUTFChars(jkey, key);
            ThrowVeriFingerException(env, VFE_INVALID_SERIAL_NUMBER);
            return;
        }

        int res = VFRegister((char*)serial, (char*)key);        
        
        if VFFailed(res)
            ThrowVeriFingerException(env, res);        

        env->ReleaseStringUTFChars(jkey, key);
        env->ReleaseStringUTFChars(jserial, serial);
    }
    catch(...)
    {
        ThrowJavaException(env);
    }
}

